<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'Rodnoe_exception.php';

require_once 'lib/tv/tv_group_list_screen.php';
require_once 'lib/tv/tv_channel_list_screen.php';
require_once 'lib/tv/tv_favorites_screen.php';

require_once 'Rodnoe_config.php';
require_once 'Rodnoe_api.php';
require_once 'Rodnoe_tv.php';
require_once 'Rodnoe_setup_screen.php';


///////////////////////////////////////////////////////////////////////////

class RodnoePlugin extends DefaultDunePlugin
{
    private $session;
    public function __construct()
    {
	$this->session = new RodnoeApi($this);
        $this->tv = new RodnoeTv($this->session);

        $tv_folder_views = $this->get_tv_folder_views();

        $this->add_screen(new RodnoeSetupScreen($this->session));

        $this->add_screen(new TvGroupListScreen($this->tv,
                RodnoeConfig::GET_TV_GROUP_LIST_FOLDER_VIEWS()));
        $this->add_screen(new TvChannelListScreen($this->tv,
                RodnoeConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));
        $this->add_screen(new TvFavoritesScreen($this->tv,
                RodnoeConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));


    }

    ///////////////////////////////////////////////////////////////////////

    private function get_tv_folder_views()
    {
        return RodnoeConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS();
    }
   
}

///////////////////////////////////////////////////////////////////////////
?>
