<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class RodnoeSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';
    const VERSION = '1.1.b';
    private $session;
    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(self::ID);

        $this->session = $session;
        #$this->tv = $tv;
    }

    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();
	$this->add_label($defs,'Версия:', self::VERSION);
        $show_tv = isset($plugin_cookies->show_tv) ?
            $plugin_cookies->show_tv : 'yes';
        $show_vod = isset($plugin_cookies->show_vod) ?
            $plugin_cookies->show_vod : 'yes';
            
        $login = isset($plugin_cookies->login) ?
            $plugin_cookies->login : '';
        $pass = isset($plugin_cookies->pass) ?
            $plugin_cookies->pass : '';
            
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;

 
 
        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';

        $this->add_combobox($defs,
            'show_tv', 'Показывать TV в главном меню:',
            $show_tv, $show_ops, 0, true);
        #$this->add_button($defs, 'edit_subscription', null,
         #   'Редактировать абонемент', 0);

        $this->add_text_field($defs,
            'login', 'Имя пользователя:',
            $login, 0, 0, 0, 1, 400, 0, true);
        $this->add_text_field($defs,
            'pass', 'Пароль:',
            $pass, 0, 1, 0, 1, 400, 0, true);
 
 
        $show_buf_time_ops = array();

        $show_buf_time_ops[0] = 'По умолчанию';
        $show_buf_time_ops[500] = '0.5 с';
        $show_buf_time_ops[1000] = '1 с';
        $show_buf_time_ops[2000] = '2 с';
        $show_buf_time_ops[3000] = '3 с';
        $show_buf_time_ops[5000] = '5 с';
        $show_buf_time_ops[10000] = '10 с';
        $show_buf_time_ops[15000] = '15 с';
        $show_buf_time_ops[20000] = '20 с';

        $this->add_combobox
        (
            $defs,
            'buf_time',
            'Время буферизации:',
            $buf_time, $show_buf_time_ops, 0, true
        );
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Setup: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        $control_id = $user_input->control_id;
        $new_value = $user_input->{$control_id};
	$need_close_dialog = false;
	$need_reset_controls = false;
	$post_action = null;
        hd_print("Setup: changing $control_id value to $new_value");

        if ($user_input->action_type === 'confirm')
        {
            if ($control_id === 'show_tv')
                $plugin_cookies->show_tv = $new_value;
            else if ($control_id === 'show_vod')
                $plugin_cookies->show_vod = $new_value;
            else if ($control_id === 'buf_time')
                $plugin_cookies->buf_time = $new_value;
        }
        else if ($user_input->action_type === 'apply')
        {

            if ($control_id === 'login')
                $plugin_cookies->login = $new_value;
            else if ($control_id === 'pass')
                $plugin_cookies->pass = $new_value;
  	    $need_reset_controls = true;
        }
	if ($need_reset_controls)
        {
            $defs = $this->do_get_control_defs($plugin_cookies);

            $reset_controls_action = ActionFactory::reset_controls(
                $defs, $post_action);

            if ($need_close_dialog)
            {
                return ActionFactory::close_dialog_and_run(
                    $reset_controls_action);
            }

            return $reset_controls_action;
         }
        #return ActionFactory::reset_controls(
        #    $this->do_get_control_defs($plugin_cookies));
    }


}

///////////////////////////////////////////////////////////////////////////
?>
