﻿<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';


require_once 'Rodnoe_channel.php';

///////////////////////////////////////////////////////////////////////////

class RodnoeTv extends AbstractTv
{
    public $cookie = array();

    private $session;

    public function __construct($session)
    {
       $this->session = $session;
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            RodnoeConfig::TV_FAVORITES_SUPPORTED,
            true);
    }

    public function get_fav_icon_url()
    {
        return RodnoeConfig::FAV_CHANNEL_GROUP_ICON_PATH;
    }

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////
    protected function load_channels(&$plugin_cookies)
    {
        if (!isset($plugin_cookies->login) || !isset($plugin_cookies->pass))
        {
               hd_print("Error: Authorization required!!!");
               return ;
        }
//        try
//        {

           $this->session->check_for_arch();
           $this->session->api_getcode($plugin_cookies);
            $this->load_channels_($plugin_cookies);
//        }
//        catch (Exception $e)
//        {
            
//            hd_print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!".$e);
//            throw $this->dune_api_exception($e, 'Login failed.', false);
//        }

    }

    protected function load_channels_(&$plugin_cookies)
    {
        
        

        $this->cookie =  $this->session->login_rodnoe($plugin_cookies->login,$plugin_cookies->pass);
       #TODO:0.

        if ($plugin_cookies->login == 'demo' || $plugin_cookies->pass == 'demo')
        {
               $xml = $this->session->get_groups_tv($this->cookie);
        }
       else
       {
               $xml = $this->session->load_groups();
       }

        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;


        $this->channels = new HashedArray();
        $this->groups = new HashedArray();

        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    RodnoeConfig::FAV_CHANNEL_GROUP_CAPTION,
                    RodnoeConfig::FAV_CHANNEL_GROUP_ICON_PATH));
        }

        $this->groups->put(
            new AllChannelsGroup(
                $this,
                RodnoeConfig::ALL_CHANNEL_GROUP_CAPTION,
                RodnoeConfig::ALL_CHANNEL_GROUP_ICON_PATH));


        foreach ($xml->groups->children() as $xml_tv_category)//gruppi
        {
            if ($xml_tv_category->getName() !== 'item')
            {
                hd_print("Error: unexpected node '" . $xml_tv_category->getName() .
                    "'. Expected: 'item'");
                throw new Exception('Invalid XML document');
            }

            $this->groups->put(
                new DefaultGroup(
                    strval($xml_tv_category->id),
                    strval($xml_tv_category->name),
                    RodnoeConfig::TV_CHANNEL_GROUP_ICON_PATH . strval($xml_tv_category->id) . ".png"));
       }

       $xml = $this->session->load_tv_list($this->cookie);
        $chnum = 1;
        foreach ($xml->channels->children() as $xml_tv_channel)
        {
            if ($xml_tv_channel->getName() !== 'item')
            {
                hd_print("Error: unexpected node '" . $xml_tv_channel->getName() .
                    "'. Expected: 'item'");
                throw new Exception('Invalid XML document');
            }


           $icon1 = "http://file2.npage.de/012382/37/bilder/b" . strval($xml_tv_channel->id).".png";
           #TODO:1
            $channel =
                  new RodnoeChannel(
                      intval($xml_tv_channel->id),
                      strval($xml_tv_channel->name),
                      $icon1,
                      "",
                      $chnum++,
                      6,
                      2,
                      $buf_time,
                     intval($xml_tv_channel->protected),
                     intval($xml_tv_channel->has_archive),
                     intval($xml_tv_channel->is_video));

             $this->channels->put($channel);

            $channeltmp = intval($xml_tv_channel->group_id);
            if ( $channeltmp >= 190 && $channeltmp<=191 || $channeltmp == 197|| $channeltmp == 202)
            {
               $tv_category_id = 15;
            }
            elseif ($channeltmp >= 33 && $channeltmp<=38 ||$channeltmp >= 183 && $channeltmp<=188 ||$channeltmp >= 198 && $channeltmp<=201 ||$channeltmp >= 169 && $channeltmp<=174 ||$channeltmp >= 183 && $channeltmp<=188 ||$channeltmp >= 205 && $channeltmp<=208 || $channeltmp == 222)
            {
               $tv_category_id = 1;
            }
            elseif ($channeltmp >= 29 && $channeltmp <= 32 || $channeltmp >= 45 && $channeltmp <= 49 || $channeltmp >= 150 && $channeltmp <= 152 || $channeltmp >= 192 && $channeltmp <= 196 || $channeltmp == 82 || $channeltmp == 203 || $channeltmp == 223 || $channeltmp == 226 || $channeltmp == 180 || $channeltmp == 182 || $channeltmp == 189 || $channeltmp == 39)
            {
               $tv_category_id = 2;
            }
            elseif ($channeltmp >= 120 && $channeltmp <= 122 || $channeltmp >= 124 && $channeltmp <= 136 || $channeltmp >= 138 && $channeltmp <= 147)
            {
               $tv_category_id = 5;
            }
            elseif ($channeltmp == 86 || $channeltmp == 106 || $channeltmp == 108)
            {
               $tv_category_id = 7;
            }
            elseif ($channeltmp == 148 || $channeltmp >= 66 && $channeltmp <= 81 || $channeltmp == 149)
            {
               $tv_category_id = 6;
            }
            elseif ($channeltmp >= 109 && $channeltmp <= 119 || $channeltmp == 137 || $channeltmp == 165 || $channeltmp == 221 || $channeltmp == 225)
            {
               $tv_category_id = 8;
            }
            elseif ($channeltmp >= 153 && $channeltmp <= 164 || $channeltmp == 41 || $channeltmp == 44 || $channeltmp == 107 || $channeltmp == 166 || $channeltmp == 167 || $channeltmp == 204 || $channeltmp == 224)
            {
               $tv_category_id = 3;
            }
            elseif ($channeltmp == 40 || $channeltmp >= 50 && $channeltmp <= 65 || $channeltmp == 83 || $channeltmp == 84)
            {
               $tv_category_id = 4;
            }
            elseif ($channeltmp >= 209 && $channeltmp <= 220)
            {
               $tv_category_id = 11;
            }
           # elseif ($channeltmp == 214 || $channeltmp >= 216 && $channeltmp <= 224 || $channeltmp >= 228 && $channeltmp <= 238 || $channeltmp >= 243 && $channeltmp <= 247 || $channeltmp == 255 || $channeltmp == 256)
             elseif ($channeltmp == 133 || $channeltmp == 69 || $channeltmp == 110)
            {
               $tv_category_id = 14;
            }
            elseif ($channeltmp >= 168 && $channeltmp <= 178 || $channeltmp == 181)
            {
               $tv_category_id = 13;
            }
            elseif ($channeltmp == 43 || $channeltmp == 85 || $channeltmp == 179)
            {
               $tv_category_id = 10;
            }
            else
            {
                $tv_category_id = intval($xml_tv_channel->group_id);
            }
             $group = $this->groups->get($tv_category_id);

                // Link group and channel.
             $channel->add_group($group);
             $group->add_channel($channel);
        }
//
       $xml = $this->session->load_radio_list($this->cookie);
        foreach ($xml->groups->item->channels->children() as $xml_tv_channel)
        {
            if ($xml_tv_channel->getName() !== 'item')
            {
                hd_print("Error: unexpected node '" . $xml_tv_channel->getName() .
                    "'. Expected: 'item'");
                throw new Exception('Invalid XML document');
            }


           $icon1 = "http://file-teleport.com/iptv/core/img/ico/radio/" . strval($xml_tv_channel->icon).".gif";
           $idradio = intval($xml_tv_channel->id) + 1000;
           #TODO:1
            $channel =
                  new RodnoeChannel(
                      $idradio,
                      strval($xml_tv_channel->name),
                      $icon1,
                      "",
                      $chnum++,
                      0,
                      0,
                      $buf_time,
                     0,
                     0,
                     intval($xml_tv_channel->is_video));

             $this->channels->put($channel);
            $tv_category_id = 16 ;
             $group = $this->groups->get($tv_category_id);

                // Link group and channel.
             $channel->add_group($group);
             $group->add_channel($channel);
        }
     }

    ///////////////////////////////////////////////////////////////////////////
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
        $this->ensure_channels_loaded($plugin_cookies);

        $cid = $this->get_channel($channel_id)->get_id();
       $cc = $this->get_channel($channel_id)->is_video();
       hd_print("---> is_video: $cc");
       $this->session->check_for_arch();
       #TODO:2

       hd_print("--->>> channel:$cid, archive:$archive_ts, protect:$protect_code, sid:$this->cookie ");
       if ( $cc == 0 )
               {
                       $radio = $cid - 1000;
                       $xml = $this->session->get_url_radio($radio,$this->cookie);
                       $tmp = urldecode($xml->url);
               }
       else
               {
                       $xml = $this->session->get_url_tv($cid,$archive_ts,$protect_code,$this->cookie);
                       if (intval($archive_ts) < 0)
                       {
                               $tmp = str_ireplace("http://", "http://ts://", $xml->url);
                       }
                       else
                       {
                               $tmp = str_ireplace("http://", "http://ts://127.0.0.1:1000/cgi-bin/arch?http://", $xml->url);
                       }
               }
        #$tmp = str_ireplace("http://", "http://ts://", $xml->url);
        hd_print("_____tmp $tmp");
       #TODO:3
       $url = $tmp;
        hd_print("--->>> URL: $url");

        return $url;
    }

    ///////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {
        $epg = array();

        hd_print("--->>> day_start_ts: $day_start_ts");
        #использовалось с api 0.7
        #$day = HD::format_timestamp($day_start_ts, "ymd");


       $cc = $this->get_channel($channel_id)->is_video();
       if ($cc == 0)
       {
            $epg[] =
                new DefaultEpgItem(
                    "ТВ Программа отсутствует",
                    "",//strval($epg_item->description),
                    "",//intval($epg_item->begin),
                    0/*intval($epg_item->stop_time)*/);
       }
       else
       {
               $xml = $this->session->get_rodnoe_epg($day_start_ts,$channel_id,$this->cookie);
               if ($xml->channels->item->getName() !== 'item')
               {
                       $epg[] =
                               new DefaultEpgItem(
                                       "ТВ Программа отсутствует",
                                       "",//strval($epg_item->description),
                                       "",//intval($epg_item->begin),
                                       0/*intval($epg_item->stop_time)*/);
               }


               else
               {

                               foreach ($xml->channels->item->epg->children() as $epg_item)
                               {
                                       if ($epg_item->getName() !== 'item')
                                       {
                                               hd_print("Error: unexpected node '" . $epg_item->getName() ."'. Expected: 'item'");
                                               throw new Exception('Invalid XML document');
                                       }
                                       else
                                       {
                                             $epg[] =
                                                       new DefaultEpgItem(
                                                       strval($epg_item->title),
                                                       strval($epg_item->info),
                                                       intval($epg_item->begin),
                                                       0/*intval($epg_item->stop_time)*/);
                                       }
                               }
               }

       }
       return new EpgIterator(
                       $epg,
                       $day_start_ts,
                       $day_start_ts + 86400);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
